=== src/ui/CMakeLists.txt ===
# ASEPRITE
# Copyright (C) 2001-2014  David Capello

add_library(ui-lib
  accelerator.cpp
  alert.cpp
  box.cpp
  button.cpp
  clipboard.cpp
  combobox.cpp
  component.cpp
  cursor.cpp
  custom_label.cpp
  draw.cpp
  entry.cpp
  event.cpp
  graphics.cpp
  grid.cpp
  image_view.cpp
  int_entry.cpp
  intern.cpp
  keys.cpp
  label.cpp
  link_label.cpp
  listbox.cpp
  listitem.cpp
  manager.cpp
  menu.cpp
  message.cpp
  message_loop.cpp
  overlay.cpp
  overlay_manager.cpp
  paint_event.cpp
  panel.cpp
  popup_window.cpp
  preferred_size_event.cpp
  property.cpp
  register_message.cpp
  resize_event.cpp
  scroll_bar.cpp
  separator.cpp
  slider.cpp
  splitter.cpp
  system.cpp
  textbox.cpp
  theme.cpp
  timer.cpp
  tooltips.cpp
  ui.cpp
  view.cpp
  viewport.cpp
  widget.cpp
  window.cpp)
