=== src/webserver/CMakeLists.txt ===
# ASEPRITE
# Copyright (C) 2001-2013  David Capello

add_library(webserver-lib
  webserver.cpp)
