=== debian/changelog ===
aseprite (1.0.5+ds-2) unstable; urgency=medium

  * debian/patches/disable-resize_image_tests.patch:
    - Added. The bug that caused the test to fail was reported upstream.
      The package is useful despite the bug (Closes: #765291).
  * Bump Standards-Version to 3.9.6.

 -- Tobias Hansen <thansen@debian.org>  Tue, 14 Oct 2014 18:49:29 +0200

aseprite (1.0.5+ds-1) unstable; urgency=medium

  * New upstream release (Closes: #762215).
  * Change Build-Dependency to libjpeg-dev for the libjpeg-turbo
    transition (Closes: #763463).
  * debian/patches/as-needed.patch:
    - Deleted. Was applied upstream.
  * debian/patches/define-O_BINARY.patch:
    - Added. Needed to build on Linux.
  * debian/patches/giflib-4.1.6.patch:
    - Added. Otherwise giflib 5.1 is required.
  * debian/patches/libx11-underlinkage.patch:
    - Updated to apply to changed source.
  * debian/patches/fix-unittests.patch:
    - Added. Remove a unit test that cannot work.
  * debian/patches/disable-file-unittest.patch:
    - Renamed from disable-file-unittest.patch and updated.
      gif_tests segfaults too, apparently for the same
      reason as file_tests.
  * Update manpage.
  * Update debian/copyright.
  * Bump Standards-Version to 3.9.5.
  * Update debian/watch.
  * Do not install data/www (not needed and fetches jquery from the net).

 -- Tobias Hansen <thansen@debian.org>  Tue, 30 Sep 2014 23:52:22 +0200
